rollout flightstudio_tools_rollout "FlightStudio Tools" width:318 height:531
(
	slider campos_slider "" pos:[23,247] width:266 height:25
	spinner camerapos "" pos:[162,227] width:86 height:16
	button launch_app1 "Launch" pos:[21,354] width:47 height:22
	edittext app_edit1 "" pos:[78,352] width:158 height:23
	button set_app1 "Set App" pos:[241,353] width:44 height:22
	button lod_more "More" pos:[98,195] width:48 height:22
	button lod_most "Most" pos:[31,195] width:48 height:22
	button lod_less "Less" pos:[165,195] width:48 height:22
	button lod_least "Least" pos:[232,195] width:48 height:22
	label lbl5 "You can specify programs to launch. Set application to executable file." pos:[50,314] width:190 height:34
	label lbl10 ":" pos:[70,356] width:9 height:18
	button launch_app2 "Launch" pos:[21,379] width:47 height:22
	edittext app_edit2 "" pos:[78,377] width:158 height:23
	button set_app2 "Set App" pos:[241,378] width:44 height:22
	label lbl11 ":" pos:[70,381] width:9 height:18
	button launch_app3 "Launch" pos:[21,404] width:47 height:22
	edittext app_edit3 "" pos:[78,402] width:158 height:23
	button set_app3 "Set App" pos:[241,403] width:44 height:22
	label lbl12 ":" pos:[70,406] width:9 height:18
	button launch_app4 "Launch" pos:[21,429] width:47 height:22
	edittext app_edit4 "" pos:[78,428] width:158 height:23
	button set_app4 "Set App" pos:[241,428] width:44 height:22
	label lbl13 ":" pos:[69,431] width:9 height:18
	button launch_browser "Browser" pos:[16,14] width:44 height:22
	button launch_fltout "flt out" pos:[71,14] width:44 height:22
	button launch_fltin "flt in" pos:[126,14] width:44 height:22
	GroupBox grp2 "Level of Detail" pos:[10,174] width:291 height:113
	GroupBox grp4 "Programs" pos:[10,298] width:290 height:213
	edittext load_this_file "" pos:[70,479] width:215 height:23
	checkbox usedefaultfile "Use Last Imported FLT file" pos:[23,461] width:152 height:18
	button set_file_button "Set File" pos:[23,480] width:44 height:22
	label lbl9 "Set LOD Distance" pos:[31,227] width:114 height:21
	
	-- set inifile to the exact location of the fstools.ini
	-- leave blank if location unknown
	-- example: inifile = "c:\\3dsmax6\\scripts\\tools.ini"
	local inifile = ""
	
	fn resetLODs =
	(
		current = flightstudio.getloddistance()
		flightstudio.lodmostdetail()
		mostdist = flightstudio.getloddistance()
		flightstudio.lodleastdetail()
		leastdist = flightstudio.getloddistance()
		flightstudio.setloddistance current
		camerapos.range = [mostdist,leastdist,current]
		camerapos.value = current
		campos_slider.range = [mostdist,leastdist,current]
		campos_slider.value = current
	)
	
	fn newImportFile =
	(		
		resetLODs()
		if(usedefaultfile.state == true) then
		(
			t3 = flightstudio.getlastimport()
			load_this_file.text = "\"" + t3 + "\""
		)
	)
	

	
	checkbox chk5 "Materials" pos:[21,75] width:71 height:17 checked:true
	checkbox chk6 "Textures" pos:[21,97] width:71 height:17 checked:true
	checkbox chk7 "Face" pos:[106,119] width:48 height:17 checked:true
	checkbox chk12 "Group" pos:[106,75] width:52 height:17 checked:true
	checkbox chk13 "Object" pos:[106,97] width:71 height:17 checked:true
	checkbox chk14 "LOD" pos:[236,75] width:53 height:17 checked:true
	checkbox chk15 "DOF" pos:[172,141] width:71 height:17 checked:true
	checkbox chk16 "Light St" pos:[172,75] width:58 height:17 checked:true
	checkbox chk17 "Cat" pos:[236,119] width:45 height:17 checked:true
	checkbox chk18 "BSP" pos:[236,97] width:56 height:17 checked:true
	checkbox chk30 "Light Pt" pos:[172,97] width:56 height:17 checked:true
	checkbox chk31 "XRef" pos:[21,119] width:54 height:17 checked:true
	GroupBox grp8 "Ignore Nodes on Import" pos:[10,53] width:291 height:116
	checkbox chk71 "Switch" pos:[172,119] width:56 height:17 checked:true
	checkbox chk72 "Clip" pos:[236,140] width:45 height:17 checked:true
	on flightstudio_tools_rollout open do
	(
		format "\nFlight Studio Tools 1.0\n\n"
		
		resetLODs()
		
		if(inifile == "") then
			inifile = scriptspath + "\\fstools.ini"
		if(doesfileexist(inifile) == false) then
		(
			f = getOpenFileName caption:"Open .ini files:" types:"INI (*.ini)|*.ini|All|*.*|" 
			if( f != undefined ) then  
	 			inifile = f
			else
				inifile = "fstools.ini"			
		)
		format "inifile %\n" inifile
				
		app_edit1.text = getinisetting inifile "FlightStudioTools" "App1"
		app_edit2.text = getinisetting inifile  "FlightStudioTools" "App2"
		app_edit3.text = getinisetting inifile  "FlightStudioTools" "App3"
		app_edit4.text = getinisetting inifile  "FlightStudioTools" "App4"
		t1 = getinisetting inifile  "FlightStudioTools" "UseCurrent"
		if(t1 == "0") then 
		(
			t2 = getinisetting inifile  "FlightStudioTools" "LoadThisFile"
			load_this_file.text = "\"" + t2 + "\""
			usedefaultfile.state = false
		)
		else
		(
			t4 = flightstudio.getlastimport()
			load_this_file.text = "\"" + t4 + "\""
			load_this_file.enabled = false
			usedefaultfile.state = true
			set_file_button.enabled = false
		)
	
		callbacks.removescripts #postImport
		callbacks.addscript #postImport "flightstudio_tools_rollout.newImportFile()" 	
	)
	on flightstudio_tools_rollout close do
	(
		setinisetting inifile  "FlightStudioTools" "App1" app_edit1.text
		setinisetting inifile  "FlightStudioTools" "App2" app_edit2.text
		setinisetting inifile  "FlightStudioTools" "App3" app_edit3.text
		setinisetting inifile  "FlightStudioTools" "App4" app_edit4.text
		if(usedefaultfile.state == false) then
			setinisetting inifile  "FlightStudioTools" "UseCurrent" "0"
		else
			setinisetting inifile  "FlightStudioTools" "UseCurrent" "1"
		setinisetting inifile  "FlightStudioTools" "LoadThisFile" load_this_file.text
	)
	on campos_slider changed val do
	(
		camerapos.value = val
		flightstudio.setloddistance camerapos.value
	)
	on camerapos changed val do
	(
		flightstudio.setloddistance val
		campos_slider.value = val
	)
	on launch_app1 pressed do
	( 
		shelllaunch app_edit1.text load_this_file.text
	)
	on set_app1 pressed do
	(
		f = getOpenFileName caption:"Open .EXE files:" types:"Executable (*.exe)|*.exe|All|*.*|" 
		if( f != undefined ) then  (
	 		app_edit1.text = f
		)
	)
	on lod_more pressed do
	(
		FlightStudio.LodMoreDetail()
		dist = flightstudio.getloddistance()
		camerapos.value = dist
		campos_slider.value = dist
	)
	on lod_most pressed do
	(
		FlightStudio.LodMostDetail()
		dist = flightstudio.getloddistance()
		camerapos.value = dist
		campos_slider.value = dist
	)
	on lod_less pressed do
	(
		FlightStudio.LodLessDetail()
		dist = flightstudio.getloddistance()
		camerapos.value = dist
		campos_slider.value = dist
	)
	on lod_least pressed do
	(
		FlightStudio.LodLeastDetail()
		dist = flightstudio.getloddistance()
		camerapos.value = dist
		campos_slider.value = dist
	)
	on launch_app2 pressed do
	( 
		shelllaunch app_edit2.text load_this_file.text
	)
	on set_app2 pressed do
	(
		f = getOpenFileName caption:"Open .EXE files:" types:"Executable (*.exe)|*.exe|All|*.*|" 
		if( f != undefined ) then  (
	 		app_edit2.text = f
		)
	)
	on launch_app3 pressed do
	( 
		shelllaunch app_edit3.text load_this_file.text
	)
	on set_app3 pressed do
	(
		f = getOpenFileName caption:"Open .EXE files:" types:"Executable (*.exe)|*.exe|All|*.*|" 
		if( f != undefined ) then  (
	 		app_edit3.text = f
		)
	)
	on launch_app4 pressed do
	( 
		shelllaunch app_edit4.text load_this_file.text
	)
	on set_app4 pressed do
	(
		f = getOpenFileName caption:"Open .EXE files:" types:"Executable (*.exe)|*.exe|All|*.*|" 
		if( f != undefined ) then  (
	 		app_edit4.text = f
		)
	)
	on launch_browser pressed do
	(
		FlightStudio.Browser()
	)
	on launch_fltout pressed do
	(
		f = getSaveFileName caption:"Open .FTL files:" types:"OpenFlight (*.flt)|*.flt|All|*.*|" 
			if( f != undefined ) then  (
			deletefile f
	 		exportFile f
		)
	)
	on launch_fltin pressed do
	( 
		resetmaxfile #noprompt
		f = getOpenFileName caption:"Open .FTL files:" types:"OpenFlight (*.flt)|*.flt|All|*.*|" 
		if( f != undefined ) then  (
	 		importFile f
		)
	)
	on usedefaultfile changed t3 do
	(
		if(t3 == true) then
		(
			load_this_file.text = "\"" + flightstudio.getlastimport() + "\""
			load_this_file.enabled = false
			set_file_button.enabled = false
		)
		else
		(
			load_this_file.enabled = true
			set_file_button.enabled = true
		)
	)
	on set_file_button pressed do
	(
		f = getOpenFileName caption:"Open .FTL files:" types:"OpenFlight (*.flt)|*.flt|All|*.*|" 
		if( f != undefined ) then  (
	 		load_this_file.text = "\"" + f + "\""
		)	
	)
	on chk5 changed state do
	(
		flightstudioimport.setignorematerials (not chk5.state)
		format "set ignore materials %\n" (not chk5.state)
	)
	on chk6 changed state do
	(
		flightstudioimport.setignoretextures (not chk6.state)
		format "set ignore textures %\n" (not chk6.state)
	)
)
-- 
--
createdialog flightstudio_tools_rollout 


