-----------------------------------------------------------
-- Skin Envelope Manipulator
-- Last Modified: 2007.01.30
-- by MikeMS
-- This script can help you with skinning process. ;)
-- Tested only in MAX 2008!
-- Script still have some "Undo" bugs...
-- Any question and wishes you can send to: mikems_kgd@mail.ru
-----------------------------------------------------------

macroScript SkinEnvelopeManipulator
icon:#("SEMtoolbarIcon",1)
category:"MikeMS"
toolTip:"Skin Envelope Manipulator"
ButtonText:"SEM"
(

global EP=0
global EPoldVal=0
global SP=0
global SPoldVal=0
global SelBoneIndex = 1
global SkinEnvelopeManipulator
global SpinnersInitVal=0
global oldOuterCS2val=0
global oldOuterCS1val=0
global oldInnerCS2val=0
global oldInnerCS1val=0
global oldEndPointPos=[0,0,0]
global oldStartPointPos=[0,0,0]
global NewEndPointPos=[0,0,0]
global NewStartPointPos=[0,0,0]
global EndPointMovedDist=[0,0,0]
global StartPointMovedDist=[0,0,0]
global tmpHandler
global MyTrigger = 0
global ParamChanged
global MoveStartPoint
global MoveEndPoint
global MyUndo
global SOlvlChanged
global ReInit


fn ParamChanged = (
	NewEndPointPos = skinOps.getEndPoint selection[1].modifiers[#Skin] SelBoneIndex
	NewStartPointPos = skinOps.getStartPoint selection[1].modifiers[#Skin] SelBoneIndex

	if skinOps.getEndPoint selection[1].modifiers[#Skin] SelBoneIndex != oldEndPointPos do MyTrigger = 1
	if skinOps.getStartPoint selection[1].modifiers[#Skin] SelBoneIndex != oldStartPointPos do MyTrigger = 2
	
	if MyTrigger == 1 do (
		MoveStartPoint()
		oldEndPointPos = skinOps.getEndPoint selection[1].modifiers[#Skin] SelBoneIndex
		oldStartPointPos = skinOps.getStartPoint selection[1].modifiers[#Skin] SelBoneIndex
	)
	if MyTrigger == 2 do (
		MoveEndPoint()
		oldStartPointPos = skinOps.getStartPoint selection[1].modifiers[#Skin] SelBoneIndex
		oldEndPointPos = skinOps.getEndPoint selection[1].modifiers[#Skin] SelBoneIndex
	)
	
	MyTrigger = 0
)


fn MoveStartPoint = (
	EndPointMovedDist = oldEndPointPos - NewEndPointPos
	skinOps.setStartPoint selection[1].modifiers[#Skin] SelBoneIndex (oldStartPointPos - EndPointMovedDist)
)

fn MoveEndPoint = (
	StartPointMovedDist = oldStartPointPos - NewStartPointPos
	skinOps.setEndPoint selection[1].modifiers[#Skin] SelBoneIndex (oldEndPointPos - StartPointMovedDist)
)

fn MyUndo = (
	if (selection.count > 0 and modPanel.getCurrentObject() == selection[1].modifiers[#skin]) and subobjectLevel == 1 and skinOps.GetNumberBones selection[1].modifiers[#Skin] > 0 do with undo "CS_Selector Changes" on (
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2)
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2)
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1)
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1)
	)
)

fn SOlvlChanged = (
	if (selection.count > 0 and modPanel.getCurrentObject() == selection[1].modifiers[#skin]) and subobjectLevel == 1 and skinOps.GetNumberBones selection[1].modifiers[#Skin] > 0 do (
		ReInit()
		MyUndo()
	)
)

fn ReInit = (
	if (selection.count > 0 and modPanel.getCurrentObject() == selection[1].modifiers[#skin]) and subobjectLevel == 1 and skinOps.GetNumberBones selection[1].modifiers[#Skin] > 0 then 
	(
		
		SkinEnvelopeManipulator.spn_OuterCS2.enabled=true
		SkinEnvelopeManipulator.spn_InnerCS2.enabled=true
		SkinEnvelopeManipulator.spn_EndPoint.enabled=true
		SkinEnvelopeManipulator.spn_OuterCS1.enabled=true
		SkinEnvelopeManipulator.spn_InnerCS1.enabled=true
		SkinEnvelopeManipulator.spn_StartPoint.enabled=true
		SkinEnvelopeManipulator.btn_OuterCS2.enabled=true
		SkinEnvelopeManipulator.btn_InnerCS2.enabled=true
		SkinEnvelopeManipulator.btn_EndPoint.enabled=true
		SkinEnvelopeManipulator.btn_OuterCS1.enabled=true
		SkinEnvelopeManipulator.btn_InnerCS1.enabled=true
		SkinEnvelopeManipulator.btn_StartPoint.enabled=true
		SkinEnvelopeManipulator.btn_PrevBone.enabled=true
		SkinEnvelopeManipulator.btn_NextBone.enabled=true
		SkinEnvelopeManipulator.ckb_L_Outers.enabled=true
		SkinEnvelopeManipulator.ckb_L_Inners.enabled=true
		SkinEnvelopeManipulator.ckb_L_Points.enabled=true

		SelBoneIndex = skinOps.GetSelectedBone selection[1].skin
		SkinEnvelopeManipulator.spn_OuterCS2.value = skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2
		SkinEnvelopeManipulator.spn_InnerCS2.value = skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2
		SkinEnvelopeManipulator.spn_OuterCS1.value = skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1
		SkinEnvelopeManipulator.spn_InnerCS1.value = skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1
		oldOuterCS2val=SkinEnvelopeManipulator.spn_OuterCS2.value
		oldOuterCS1val=SkinEnvelopeManipulator.spn_OuterCS1.value
		oldInnerCS2val=SkinEnvelopeManipulator.spn_InnerCS2.value
		oldInnerCS1val=SkinEnvelopeManipulator.spn_InnerCS1.value
		SkinEnvelopeManipulator.lbl_SelectedBone.text = skinOps.GetBoneName selection[1].skin SelBoneIndex 1
		
		oldEndPointPos = skinOps.getEndPoint selection[1].modifiers[#Skin] SelBoneIndex
		oldStartPointPos = skinOps.getStartPoint selection[1].modifiers[#Skin] SelBoneIndex
		MyTrigger = 0
		
	)
	else
	(
		SkinEnvelopeManipulator.spn_OuterCS2.enabled=false
		SkinEnvelopeManipulator.spn_InnerCS2.enabled=false
		SkinEnvelopeManipulator.spn_EndPoint.enabled=false
		SkinEnvelopeManipulator.spn_OuterCS1.enabled=false
		SkinEnvelopeManipulator.spn_InnerCS1.enabled=false
		SkinEnvelopeManipulator.spn_StartPoint.enabled=false
		SkinEnvelopeManipulator.btn_OuterCS2.enabled=false
		SkinEnvelopeManipulator.btn_InnerCS2.enabled=false
		SkinEnvelopeManipulator.btn_EndPoint.enabled=false
		SkinEnvelopeManipulator.btn_OuterCS1.enabled=false
		SkinEnvelopeManipulator.btn_InnerCS1.enabled=false
		SkinEnvelopeManipulator.btn_StartPoint.enabled=false
		SkinEnvelopeManipulator.btn_PrevBone.enabled=false
		SkinEnvelopeManipulator.btn_NextBone.enabled=false
		SkinEnvelopeManipulator.lbl_SelectedBone.text = "No bones..."
		SkinEnvelopeManipulator.ckb_L_Outers.enabled=false
		SkinEnvelopeManipulator.ckb_L_Inners.enabled=false
		SkinEnvelopeManipulator.ckb_L_Points.enabled=false
	)
)

registerRedrawViewsCallback ReInit

callbacks.removeScripts id:#SOlvlCatcher
callbacks.addScript #ModPanelSubObjectLevelChanged "SOlvlChanged()" id:#SOlvlCatcher

rollout SkinEnvelopeManipulator "Skin Envelope Manip.  by MikeMS" width:252 height:142
(
	bitmap backImg pos:[-2,-3] fileName:(getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_back.bmp") frame:false
	button btn_OuterCS2 "Outer CS L" pos:[8,8] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 1, 1, 13, 1) toolTip:"Select Left Outer Cross Section"
	button btn_InnerCS2 "Inner CS L" pos:[8,48] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 2, 2, 14, 2) toolTip:"Select Left Inner Cross Section"
	button btn_EndPoint "End Point L" pos:[8,88] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 3, 3, 15, 3) toolTip:"Select Left Outer End Point"
	button btn_OuterCS1 "Outer CS R" pos:[212,8] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 4, 4, 16, 4) toolTip:"Select Left Outer Cross Section"
	button btn_InnerCS1 "Inner CS R" pos:[212,48] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 5, 5, 17, 5) toolTip:"Select Left Inner Cross Section"
	button btn_StartPoint "Start Point R" pos:[212,88] width:32 height:32 images:#((getDir #maxroot+"\\Scripts\\SkinEnvelopeManipulator\\CS_Selector_buttons.bmp"), undefined, 18, 6, 6, 18, 6) toolTip:"Select Left Outer End Point"
	spinner spn_OuterCS2 "" pos:[46,16] width:64 height:16 range:[0,100000,SpinnersInitVal] toolTip:"Change Left Outer Cross Section Radius"
	spinner spn_InnerCS2 "" pos:[46,56] width:64 height:16 range:[0,100000,SpinnersInitVal] toolTip:"Change Left Inner Cross Section Radius"
	spinner spn_EndPoint "" pos:[46,96] width:64 height:16 range:[-100,100,0] scale: 0.1 toolTip:"Change Right Outer And Inner Cross Sections Radius Together"
	spinner spn_OuterCS1 "" pos:[141,16] width:64 height:16 range:[0,100000,SpinnersInitVal] toolTip:"Change Left Outer Cross Section Radius"
	spinner spn_InnerCS1 "" pos:[141,56] width:64 height:16 range:[0,100000,SpinnersInitVal] toolTip:"Change Left Inner Cross Section Radius"
	spinner spn_StartPoint "" pos:[141,96] width:64 height:16 range:[-100,100,0] toolTip:"Change Left Outer And Inner Cross Sections Radius Together"
	checkButton ckb_L_Outers "L" pos:[118,12] width:17 height:23 toolTip:"Lock Outer Cross Sections Radius"
	checkButton ckb_L_Inners "L" pos:[118,52] width:17 height:23 toolTip:"Lock Inner Cross Sections Radius"
	checkButton ckb_L_Points "L" pos:[118,92] width:17 height:23 toolTip:"Lock All Cross Sections Radius And EndPoints Position"
	button btn_PrevBone "<" pos:[7,126] width:16 height:14 toolTip:"Select previous bone"
	button btn_NextBone ">" pos:[26,126] width:16 height:14 toolTip:"Select next bone"
	label lbl_SelectedBone "No bone..." pos:[48,126] width:120 height:14
	button btn_Help "?" pos:[228,126] width:16 height:14 toolTip:"Help &&& About"

on btn_OuterCS2 pressed do
	(
		skinOps.SelectCrossSection selection[1].skin 2 1
	)
on btn_InnerCS2 pressed do
	(
		skinOps.SelectCrossSection selection[1].skin 2 0
	)
on btn_EndPoint pressed do
	(	
		skinOps.SelectEndPoint selection[1].skin
	)
on btn_OuterCS1 pressed do
	(
		skinOps.SelectCrossSection selection[1].skin 1 1
	)
on btn_InnerCS1 pressed do
	(
		skinOps.SelectCrossSection selection[1].skin 1 0
	)
on btn_StartPoint pressed do
	(
		skinOps.SelectStartPoint selection[1].skin
	)
on btn_PrevBone pressed do
	(
		skinOps.selectPreviousBone selection[1].skin
		SelBoneIndex = skinOps.GetSelectedBone selection[1].skin
	)
on btn_NextBone pressed do
	(
		skinOps.selectNextBone selection[1].skin
		SelBoneIndex = skinOps.GetSelectedBone selection[1].skin
	)
	
on btn_Help pressed do
	(
	messagebox "Hi! With this script you can fast and easy setup skin Envelopes for your character or other object that has skin modifier.
This script is free. But, use it on your own risk...\n
Six big buttons on the sides of the script window lets you select corresponded Cross Sections or End Points.
Three buttons on center with L-word lets you lock radius value of the left and right Cross Sections.
Spinners near this Selection Buttons will change radius directly.
Spinners near End Points Selection Button will change Inner and Outer radius of the Cross Section together.
Also, when you lock EndPoints, End Points of the Envelope will moves together!
Two small buttons in bottom left corner allows you change the active bone in skin modifier list back and forward directly.

Script was developed for work with only 2 Cross Sections per Bone. Use it with more than 2 Cross Sections with cautions.
Be careful with Undo. Sometimes it works not correctly! But sometimes you must do the undo 2-3 times before they roll back changes...
Tested only in MAX 2008!\n
Any question and wishes you can send to: mikems_kgd@mail.ru"
	)

-- OuterCS2:
on spn_OuterCS2 changed val do
	(
	skinOps.SelectCrossSection selection[1].skin 2 1
	skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 spn_OuterCS2.value
	if skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 <= skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 do skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 - 1)
	if ckb_L_Outers.state==true do (
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (spn_OuterCS2.value - (oldOuterCS2val - spn_OuterCS1.value))
		if skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 <= skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 do skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 - 1)
		oldOuterCS2val=spn_OuterCS2.value
		)
	)
on spn_OuterCS2 entered do MyUndo()
	
-- InnerCS2:
on spn_InnerCS2 changed val do
	(
	skinOps.SelectCrossSection selection[1].skin 2 0
	skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 spn_InnerCS2.value
	if skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 >= skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 do skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + 1)
	if ckb_L_Inners.state==true do (
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (spn_InnerCS2.value - (oldInnerCS2val - spn_InnerCS1.value))
		if skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 >= skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 do skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + 1)
		oldInnerCS2val=spn_InnerCS2.value
		)
	)
on spn_InnerCS2 entered do MyUndo()
	
-- OuterCS1:
on spn_OuterCS1 changed val do
	(
	skinOps.SelectCrossSection selection[1].skin 1 1
	skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 spn_OuterCS1.value
	if skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 <= skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 do skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 - 1)
	if ckb_L_Outers.state==true do (
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (spn_OuterCS1.value - (oldOuterCS1val - spn_OuterCS2.value))
		if skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 <= skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 do skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 - 1)
		oldOuterCS1val=spn_OuterCS1.value
		)	
	)
on spn_OuterCS1 entered do MyUndo()
	
-- InnerCS1:
on spn_InnerCS1 changed val do
	(
	skinOps.SelectCrossSection selection[1].skin 1 0
	skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 spn_InnerCS1.value
	if skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 >= skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 do skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + 1)
	if ckb_L_Inners.state==true do (
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (spn_InnerCS1.value - (oldInnerCS1val - spn_InnerCS2.value))
		if skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 >= skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 do skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + 1)
		oldInnerCS1val=spn_InnerCS1.value
		)	
	)
on spn_InnerCS1 entered do MyUndo()

	
on spn_EndPoint changed val do
	(
		skinOps.SelectEndPoint selection[1].skin
		EP = val - EPoldVal
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + EP)
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + EP)
		EPoldVal = val
		if ckb_L_Points.state==true do (
			skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + EP)
			skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + EP)
			)
	)
on spn_EndPoint entered do (spn_EndPoint.value = 0; EPoldVal=0; MyUndo())

on spn_StartPoint changed val do
	(
		skinOps.SelectStartPoint selection[1].skin
		SP = val - SPoldVal
		skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + SP)
		skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 1 + SP)
		if ckb_L_Points.state==true do (
			skinOps.setOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getOuterRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + SP)
			skinOps.setInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 (skinOps.getInnerRadius selection[1].modifiers[#Skin] SelBoneIndex 2 + SP)
			)
		SPoldVal = val
	)
on spn_StartPoint entered do (spn_StartPoint.value = 0; SPoldVal=0; MyUndo())
	
on ckb_L_Points changed theState do 
(
	if theState == true then (
		try deleteAllChangeHandlers id:#tmpHandler catch()
		tmpHandler = when parameters $ changes id:#tmpHandler do ParamChanged()
	)
	else (
		try deleteAllChangeHandlers id:#tmpHandler catch()
	)
)

	
on SkinEnvelopeManipulator close do 
	(
	callbacks.removeScripts id:#SOlvlCatcher
	try deleteAllChangeHandlers id:#tmpHandler catch()
	unRegisterRedrawViewsCallback ReInit
	)
)
createDialog SkinEnvelopeManipulator SkinEnvelopeManipulator.width SkinEnvelopeManipulator.height
ReInit()
MyUndo()
)